/*
 *      s t r e a d d _ c
 *
 *  Unix compatible routine to copy a string exapnding
 *  non-graphic characters to their equivalent C language
 *  escape sequencesr.  A NULL byte is appended to the end.
 *  Thetarget area must be large enough to hold the result,
 *  but an area 4 times the size of the source is guaranteed
 *  to be large enough.
 *
 *  The exceptions string contains any characters that are
 *  not to be expanded.
 *
 *  Returns a pointer to the NULL byte at the end of the
 *  target string (cf strecpy()).
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  29 Aug 94   DJW   - First version
 */

#define __LIBRARY__

#include <libgen.h>
#include <stdlib.h>

char *  streadd _LIB_F3_(char *,        output,     \
                         const char *,  input,      \
                         const char *,  exceptions)
{
    return __streadd(output, input, exceptions,NULL);
}

